#! /bin/sh
# This is a shell archive.  Remove anything before this line, then unpack
# it by saving it into a file and typing "sh file".  To overwrite existing
# files, type "sh file -c".  You can also feed this as standard input via
# unshar, or by typing "sh <file", e.g..  If this archive is complete, you
# will see the following message at the end:
#		"End of archive 3 (of 3)."
# Contents:  prolog1.2/Impl prolog1.2/Interval/relax.ss
# Wrapped by oz@nexus.yorku.ca on Mon Jun 15 12:54:04 1992
PATH=/bin:/usr/bin:/usr/ucb ; export PATH
if test -f 'prolog1.2/Impl' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/Impl'\"
else
echo shar: Extracting \"'prolog1.2/Impl'\" \(13617 characters\)
sed "s/^X//" >'prolog1.2/Impl' <<'END_OF_FILE'
X		Scheme Prolog 1.2 Implementation Details
X		----------------------------------------
X
X
XOverview of Features
X--------------------
X
XScheme Prolog 1.2 is an interpreter for pure Prolog.  It supports delayed
Xgoals (i.e., goals which are not executed until certain conditions are met,
Xsuch as certain variables being bound) and is extensible to include predicates
Xdefined in Scheme.  The execution mechanism is based on continuations.  An
Xinterval-arithmetic package is also loaded by default, but is not described
Xin detail here.
X
X
XInvocation and Syntax
X---------------------
X
XThe interpreter is invoked by evaluating the following:
X	(pro "file"...)
Xwhere "file"... is a sequence of names of Prolog source files.  The interpreter
Ximplicitly loads "builtin.pro" (and "interval.pro" if interval arithmetic is
Xenabled) before loading the specified files.  Queries pertaining to the loaded
Xfiles are then accepted.  The interpreter is exited by typing "q" to the query
Xprompt.
X
XProlog definitions consist of two parts:  a "when" part and a "what" or "how"
Xpart.  The "when" part specifies conditions under which a goal can proceed,
Xand the "what" or "how" part specifies the meaning of the goal in terms of
Xeither Prolog (for "what" definitions) or Scheme (for "how" definitions).
X
XTypically, no "when" conditions would be specified, indicating that the goal
Xis never delayed.  Such a declaration would have the following form:
X	(when (my-func ?arg1 ?arg2))
XOne may also specify conditions of the following forms:
X	(when (my-func ?arg1 ?arg2) (nonvar ?arg1) (nonvar ?arg2))
X	(when (my-func ?arg1 ?arg2) (ground ?arg2))
XTaken together, these two declarations imply that my-func may be executed if
Xand only if (a) both of its arguments are instantiated, or (b) its second
Xargument is ground.
X
XA "what" definition has the following form:
X	(what (my-func ?arg1 ?arg2) (foo ?arg1) (bar ?arg2) (etc ?arg2))
X	(what (my-func fred ?arg))
XThis is equivalent to the following Edinburgh Prolog definition:
X	my-func(Arg1,Arg2) :- foo(Arg1), bar(Arg2), etc(Arg2).
X	my-func(fred,Arg).
X
XInstead of providing a set of "what" clauses, one may provide a single "how"
Xclause to define a predicate in Scheme, as follows:
X	(how (my-func ?arg1 ?arg2)
X	     (lambda (goal program s f) (scheme-stuff ...)))
XOnly a single "how" clause is permitted.  The meanings of the arguments to
Xthe lambda expression are explained below, under "Execution".
X
X
XInternal Representations
X------------------------
X
XInternally, variables are represented as vectors having the following four
Xcomponents:  (1) a constant which is either 'uninst for an uninstantiated
Xvariable or 'inst for an instantiated variable; (2) a unique name for the
Xparticular instance of the variable (e.g., ?foo#6); (3) the value of the
Xvariable, if instantiated (otherwise, 'no-val); and (4) a difference list
Xof delayed goals (actually predicates of the form #(when what how); refer
Xto "pred.ss" for details) awaiting instantiation of the variable.  The file
X"terms.ss" implements much of the manipulation of variables.  Manipulation
Xof difference lists is implemented by "dlists.ss".
X
X"When," "what" and "how" definitions are compiled into the forms described
Xbelow.  This compilation is done by "compile.ss".
X
XA list of "when" clauses is compiled into a single procedure which returns
X#t if and only if its argument (a goal) is ready to run; i.e., if the "when"
Xconstraints for the goal are satisfied.  This procedure will be invoked
Xbefore any instance of the goal is executed, allowing the goal to be delayed
Xif necessary.
X
XA list of "what" clauses is compiled into a corresponding list of clause-
Xinstance-creating procedures.  Each such procedure returns a pair whose car
Xrepresents the head of a clause and whose cdr is a list representing the
Xgoals in the body of the clause.  Variables are represented by their internal
Xrepresentation, as explained above.  Successive invocations of any clause-
Xinstance-creating procedure produce distinct clause instances, as evidenced
Xby the differences in the variables in the clause instances.
X
XAs an example of the invocation of a clause-instance-creating procedure,
Xconsider the following Prolog clause:
X	(what (my-func ?arg1 ?arg2) (foo ?arg1) (bar ?arg2) (etc ?arg2))
XThis clause's clause-instance-creating procedure would return a structure
Xof the following form:
X	( [my-func #(uninst ?arg1#1 no-val (()))
X		   #(uninst ?arg2#2 no-val (()))] .
X	  ( [foo #(uninst ?arg1#1 no-val (()))]
X	    [bar #(uninst ?arg2#2 no-val (()))]
X	    [etc #(uninst ?arg2#2 no-val (()))] )
X	)
XA second invocation would return a similar structure, but with different
Xvariables; e.g., instead of #(uninst ?arg1#1 no-val (())), the variable
X?arg1 might be represented by #(uninst ?arg1#3 no-val (())).
X
XA list of "how" clauses must consist of a single "how" definition, and
Xis compiled directly into the specified Scheme procedure.  This procedure
Xmust accept three arguments:  the program (described below), a success
Xcontinuation and a failure continuation.  Refer to the section entitled
X"Execution" below for a description of these continuations.  A simple
Xexample of a "how" clause is the one for "debug" in "builtin.pro".
X
XThe compiled program consists of an association list (see "tables.ss"), each
Xof whose elements represents one predicate.  A predicate is represented by a
Xpair whose car is a constant of the form name/arity (e.g., append/3) and
Xwhose cdr is a vector having the following three elements:  (1) the compiled
X"when" clause for the predicate, (2) a list of the compiled "what" clauses
X(or an empty list if the predicate is defined by a "how" clause) and (3) the
Xcompiled "how" clause (or an empty list if the predicate is defined by "what"
Xclauses).  A typical predicate definition would thus look something like this:
X	(append/3 . #(when-proc (what-proc-1 what-proc-2) ()))
X
X
XExecution
X---------
X
XThe central part of the interpreter is defined in "search.ss".  Execution is
Xbased on continuations.  AND- and OR-handling procedures, as well as the
Xunification procedure, conceptually do not return, but instead, as their last
Xaction, invoke one of two continuations (actually lambda expressions).  One
Xof these is the "success" continuation, used to implement forward execution
Xand invoked if the procedure is considered to have succeeded, and the other is
Xthe "failure" continuation, used to implement backtracking and invoked if the
Xprocedure is considered to have failed.  A "success" continuation will perform
Xthe remaining actions to be done; a "failure" continuation will undo any
Xactions taken by the calling procedure and will initiate backtracking.
X
XThere are three arguments which are supplied (among others) to the AND- and
XOR-handling procedures and unification.  These include the following:
X(1) program -- the compiled program, described above; (2) s -- the "success"
Xcontinuation; and (3) f -- the "failure" continuation.
X
XA procedure (e.g., "and-node") invokes another procedure (e.g., "and-branch")
Xas its last action, and, conceptually, does not expect the called procedure
Xto return.  Instead, the calling procedure passes to the called procedure two
Xcontinuations:  a "success" continuation and a "failure" continuation.  The
Xcalled procedure will, directly or indirectly, invoke one of these.  If the
Xcalling procedure requires further actions to be taken upon completion of the
Xcalled procedure, it places these actions into the "success" continuation
Xpassed to the called procedure.  In addition, actions to be taken upon failure
Xmay be placed by the caller in the "failure" continuation.
X
XThe "failure" continuation is a zero-argument lambda expression which simply
Xinvokes some alternative action, such as trying a different clause in order
Xto effect backtracking.  (It also undoes any actions which need to be undone
Xbefore backtracking is commenced).  The "success" continuation is somewhat more
Xcomplicated, as it must allow for future backtracking, and thus for possible
Xfuture invocation of the "failure" continuation.  The "success" continuation
Xtherefore requires a single argument, consisting of a "failure" continuation
Xwhich may be invoked in future.
X
XThe primary routines which use the "success" and "failure" continuations are
Xdescribed in detail below.  "And-node" invokes "and-branch", which invokes
X"or-node", which invokes "or-branch", which invokes "and-node", completing
Xthe cycle.  The descriptions below are intended to be read while referring
Xto the actual code in "search.ss".
X
X"And-node" has, as its first argument, a list ("terms") of goals to be
Xexecuted.  These are typically the goals in the body of a clause.  If the
Xlist is empty, "and-node" succeeds by invoking its "success" continuation.
XOtherwise, one or more goals remain, and are invoked as follows.  The first
Xgoal is invoked, via "and-branch" (indirectly via "goal-first-try!", defined
Xin "goals.ss" and described more fully below), and the remaining goals are
Xplaced in the "success" continuation passed to "and-branch" by prepending
Xthem to "and-node"'s "s" continuation.  The "success" continuation passed to
X"and-branch" is thus
X	(lambda (f) (and-node (cdr terms) program s f)).
XThe "failure" continuation passed to "and-branch" is simply "and-node"'s
X"f" continuation.
X
X"And-branch" accepts a single goal as its first argument, and attempts to
Xsolve that goal.  For a goal defined by a "how" clause, "and-branch" directly
Xinvokes the supplied Scheme procedure.  For Prolog goals, defined by "what"
Xclauses, "and-branch" passes execution to "or-node", passing its own "s" and
X"f" continuations (wrapped in some tracing/debugging code).
X
X"Or-node" has, as its first argument, a list ("clause-makers") of clause-
Xinstance-creation procedures, described above.  If this list is empty,
X"or-node" fails by invoking its "failure" continuation.  Otherwise, it tries
Xthe clause defined by the first such procedure, by invoking "or-branch".
XThe "success" continuation passed to "or-branch" is simply "or-node"'s "s"
Xcontinuation.  The "failure" continuation passed effects backtracking by
Xtrying another element of "clause-makers", and is defined as follows:
X	(lambda () (or-node (cdr clause-makers) goal program s f)).
X
X"Or-branch" attempts to unify the current goal with the head of the clause
Xchosen by "or-node".  If the unification succeeds, the body of the clause
Xis invoked via the "success" continuation passed to "unify", which is as
Xfollows:
X	(lambda (f) (and-node (clause-body clause) program s f)).
XOtherwise, the "f" continuation will be invoked.
X
X
XDelayed Goals
X-------------
X
XThe description of "and-node" above implied that "and-branch" would be
Xinvoked by "goal-first-try!".  In practice, "goal-first-try!" (defined in
X"goals.ss") invokes "and-branch" (via a "run" continuation passed to it by
X"and-node") only if the goal is ready to execute.  Otherwise, the goal is
Xdelayed.  This is done by placing it on the delayed-goal list of each of
Xthe variables involved, as well as in the floundered-goals list (refer to
X"flounder.ss").  A "delay" continuation (passed by "and-node") is then
Xinvoked, which omits execution of "and-branch" and proceeds directly to
Xthe invocation of the next goal by "and-node".  The "failure" argument
Xpassed to the delay continuation will undo the effects of delaying the goal
Xbefore invoking the original "f" continuation from "and-node".
X
XWhen a variable becomes instantiated, its delayed-goal list is checked
X("var-instantiate!" calls "var-wake-constraints"; see "terms.ss").
X"Wake-constraints" steps through the delayed-goal list, via continuations,
Xand invokes "goal-wake-try!" (defined in "goals.ss") for each.  Those goals
Xwhich are now ready to proceed are awakened by "awaken-goal!" (defined in
X"goals.ss"), and those which are not are again delayed, as described above.
X"Awaken-goal!" does not execute a goal immediately, but instead schedules
Xit (via "schedule!", defined in "schedule.ss") for execution upon the next
Xinvocation of "scheduler".  "Unify" invokes "scheduler" as its last action
Xafter the entire unification has been completed by "unify_quick".  This
Xdelay in invocation of awakened goals can, in some circumstances, prevent
Xmultiple invocations of the same goal resulting from multiple bindings
Xtaking place during the unification.
X
X
XUnification
X-----------
X
XThe basic unification algorithm ("unify" in "search.ss") is quite standard.
XThe only unusual aspect is that it makes use of "success" and "failure"
Xcontinuations to continue execution upon completion or failure.  If interval
Xarithmetic is enabled, "arith-unify" (defined in "Interval/unify.ss") allows
Xarithmetic intervals to be unified.
X
X
XTop-Level Driver
X----------------
X
XThe top-level driver for the interpreter ("prolog", defined in "programs.ss")
Xloads files via "program-load", compiles definitions via "compile" (defined
Xin "compile.ss") and accepts and attempts to solve user queries via
X"solve-queries".  A solution to a query is displayed as the query with the
Xvariables bound appropriately.  Any floundered goals are also displayed.
X"Want-more-solutions?" controls the search for further solutions after the
Xfirst is found.
X
XThe "success" continuation passed by "solve-queries" to "and-node" is the
Xmeans by which solutions are displayed and further solutions are (or are not)
Xsought.  Specifically, this continuation displays the information described
Xabove and, if "want-more-solutions?" is true, executes the "failure"
Xcontinuation passed to it in order to force backtracking.  The top-level
X"failure" continuation, passed to "and-branch", simply prints the message,
X"no more solutions".
END_OF_FILE
if test 13617 -ne `wc -c <'prolog1.2/Impl'`; then
    echo shar: \"'prolog1.2/Impl'\" unpacked with wrong size!
fi
# end of 'prolog1.2/Impl'
fi
if test -f 'prolog1.2/Interval/relax.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/Interval/relax.ss'\"
else
echo shar: Extracting \"'prolog1.2/Interval/relax.ss'\" \(15963 characters\)
sed "s/^X//" >'prolog1.2/Interval/relax.ss' <<'END_OF_FILE'
X;;; functions
X(define (last-matching list1 list2)	;;; returns tail of list1 such that
X					;;; tail's length equals list2's length
X	(define (excise ls count)
X		(if (> count 0)
X			(excise (cdr ls) (- count 1))
X			ls))
X	(excise list1 (- (length list1) (length list2))))
X
X(define (map-var-val goal binding)
X					;;; binding is a binding including
X					;;; nature
X					;;; returns (<list of vars>
X					;;; <their bindings>)
X					;;; note: (term-deref ...) and
X					;;; (term-instantiate ...) DIFFER
X					;;; for composites, and in one level
X					;;; of extra dereferencing
X					;;; note: values of vars are intervals
X	(define (func args bdgs vars var-bdgs)
X		(if	(null? args)
X			(list vars var-bdgs)
X			(let	((bdg (car bdgs))
X				(arg (term-deref (car args))))
X				(cond	((number? arg)
X						(if	(eq-int? bdg
X								(approx arg))
X							(func (cdr args)
X								(cdr bdgs)
X								vars var-bdgs)
X							(error 'map-var-val
X						"unequal constants ~d, ~d"
X								bdg (approx
X									arg))))
X					((term-var? arg)
X						(if	(memq arg vars)
X							(func (cdr args)
X								(cdr bdgs)
X								vars var-bdgs)
X							(func (cdr args)
X								(cdr bdgs)
X								(cons arg vars)
X								(cons bdg
X								    var-bdgs))))
X					(else	(error 'map-var-val
X							"unidentified term ~s"
X							arg))))))
X
X	(arith-debug "in map-var-val()")
X	(let	((goal-args (comp-cdr (goal-term goal)))
X		 (bdgs (cdr binding)))
X		(func (last-matching goal-args bdgs) bdgs '() '() )))
X
X(define (init-arith! var-set)
X					;;; returns a list of variables which
X					;;; have to be uninstantiated on
X					;;; backtracking and more ...
X	(define (func vars uninst-vars inst-vars old-bdgs)
X		(if	(null? vars)
X			(list uninst-vars inst-vars old-bdgs)
X			(let*	((var (car vars))
X				(val (var-val var)))
X					;;; abuse of (var-val ...)
X				(cond	((not (var-inst? var))
X						(var-inst! var -INFINF)
X						(func (cdr vars)
X							(cons var uninst-vars)
X							inst-vars old-bdgs))
X					((number? val)
X						(var-inst! var (approx val))
X						(func (cdr vars) uninst-vars
X							(cons var inst-vars)
X							(cons val old-bdgs)))
X					((arith-interval? val)
X						(func (cdr vars) uninst-vars
X							inst-vars old-bdgs))
X					(else	(error 'init-arith!
X						"illegal var ~s" var))))))
X
X	(arith-debug "in init-arith!()")
X	(func var-set '() '() '() ))
X
X(define (extract-args g-term)
X					;;; g-term is (goal-term goal)
X					;;; extracts args from g-term
X					;;; and makes ready for execution
X	(let	((args (comp-cdr (term-instantiate g-term))))
X					;;; still need to replace numeric
X					;;; constants by intervals
X		(map	(lambda (arg)
X				(cond	((number? arg)
X						(approx arg))
X					(else	arg)))
X			args)))
X
X(define (extract-arg-vars g-term)
X					;;; g-term is (goal-term goal)
X					;;; extracts (var) args from g-term
X					;;; used in detecting duplicated vars
X	(let	((args (comp-cdr g-term)))
X		(map	(lambda (arg)
X				(term-deref arg))
X			args)))
X
X(define (restore-var-set state var-set bindings)
X	(arith-debug "in restore-var-set() with state:")
X	(arith-debug state)
X	(arith-debug "and bindings:")
X	(arith-debug (term-instantiate bindings))
X	(cond	((eq? state 'uninst)	;;; restore to uninstantiated state?
X			(map	(lambda (var) (var-uninst! var))
X				var-set))
X		((eq? state 'inst)
X			(do	((var-set var-set (cdr var-set))
X				(bindings bindings (cdr bindings)))
X				((null? var-set))
X				(var-inst! (car var-set) (car bindings))))
X		(else	(error 'restore-var-set "illegal state passed as arg"))))
X
X(define (transform-goal goal program)
X	(let*	((g-term (goal-term goal))
X		 (name (term-functor g-term))
X		 (args (extract-arg-vars g-term))
X		 (tgoal (apply	(name->transform-func name)
X				(list args goal program))))
X		(if (not (eq? goal tgoal))
X		    (begin (arith-debug "transforming goal:")
X			   (arith-debug (term-instantiate (goal-term tgoal)))))
X		tgoal))
X
X(define (transform-add args goal program)
X	(cond	((eq? (car args) (caddr args))	;;; x + y = x --> y = 0
X			(make-goal
X				(list 'zero1 (cadr args))
X				program))
X		((eq? (cadr args) (caddr args))	;;; x + y = y --> x = 0
X			(make-goal
X				(list 'zero1 (car args))
X				program))
X		((eq? (car args) (cadr args))	;;; x + x = y --> 2 * x = y
X			(make-goal
X				(list 'mult 2 (car args) (caddr args))
X				program))
X		(else goal)))			;;; x + y = z
X
X(define (transform-mult args goal program)
X	(cond	((and	(eq? (car args) (cadr args))
X			(eq? (cadr args) (caddr args)))
X						;;; x * x = x --> x = 0|1
X			(make-goal
X				(list 'zero-one1 (car args))
X				program))
X		((eq? (car args) (caddr args))	;;; x * y = x --> x = 0 | y = 1
X			(make-goal
X				(list 'zero-one2 (car args) (cadr args))
X				program))
X		((eq? (cadr args) (caddr args))	;;; x * y = y --> y = 0 | x = 1
X			(make-goal
X				(list 'zero-one2 (cadr args) (car args))
X				program))
X		((eq? (car args) (cadr args))	;;; x * x = y --> x^2 = y
X			(make-goal
X				(list 'square (car args) (caddr args))
X				program))
X		(else goal)))			;;; x * y = z
X
X(define (transform-square args goal program)
X	(if (eq? (car args) (cadr args))	;;; x^2 = x --> x = 0 | x = 1
X		(make-goal
X			(list 'zero-one1 (car args))
X			program)
X		goal))				;;; x^2 = y
X
X(define (transform-geq args goal program)
X	(if (eq? (car args) (cadr args))	;;; x >= x --> true
X		(make-goal '(true) program)
X		goal))				;;; x >= y
X
X(define (transform-gt args goal program)
X	(if (eq? (car args) (cadr args))	;;; x > x --> fail
X		(make-goal '(fail) program)
X		goal))				;;; x > y
X
X(define (transform-neq args goal program)
X	(if (eq? (car args) (cadr args))	;;; x =/= x --> fail
X		(make-goal '(fail) program)
X		goal))				;;; x =/= y
X
X(define (transform-int args goal program) goal)	;;; int(x)
X
X(define (transform-zero-one2 args goal program)
X	(if (eq? (car args) (cadr args))	;;; x = 0 | x = 1 --> x = 0|1
X		(make-goal
X			(list 'zero-one1 (car args))
X			program)
X		goal))				;;; x = 0 | y = 1
X
X(define (transform-zero-one1 args goal program) goal)	;;; x = 0|1
X
X(define (transform-zero1 args goal program) goal)	;;; x = 0
X
X(define (relax-squeeze goal program s f)
X	(arith-debug "in relax-squeeze() with goal:")
X	(arith-debug (term-instantiate (goal-term goal)))
X	(let*	((tgoal (transform-goal goal program))	;;; no duplicated vars
X		 (g-term (goal-term tgoal))
X		 (name (term-functor g-term))
X					;;; collect all variables in goal
X		 (var-set (term-var-set g-term)))
X		(if	(not (arith-primitive? name))
X			(error 'relax-squeeze "non-arith goal in goal list"))
X					;;; initialize any uninitialized vars
X		(let*	((ret (init-arith! var-set))
X			(uninst-var-set (car ret))
X			(undo-var-set (cadr ret))
X			(undo-bindings (caddr ret))
X			(args (extract-args g-term))
X			(result (useful-bdgs (apply (name->func name) args))))
X					;;; apply instantiated transformed goal
X			(try-bdg result tgoal program s
X				(lambda ()
X					(restore-var-set 'uninst
X						uninst-var-set '())
X					(restore-var-set 'inst undo-var-set
X						undo-bindings)
X					(f))))))
X
X(define (undelay! goal var-set)
X	(map	(lambda (v)
X			(var-del-constraint! goal v))
X		var-set))
X
X(define (try-bdg result goal program s f)
X					;;; *** test me for loops ***
X	(define (delay! goal var-set where)
X					;;; note that whenever an arithmetic
X					;;; primitive is awakened,
X					;;; it is excised from the constraint-
X					;;; lists of all its vars before
X					;;; execution
X					;;; but, the sequence of variable
X					;;; instantiation DOES NOT guarantee
X					;;; this!!
X		(for-each
X			(lambda (v)
X				(var-add-constraint! goal v where))
X			var-set))
X
X	(arith-debug "in try-bdg() with binding list:")
X	(arith-debug result)
X	(if	(null? result)
X		(f)			;;; exit to Prolog on goal failure
X		(let*			;;; try another squeezed binding
X			((ret (map-var-val goal (car result)))
X			 (var-set (car ret))
X			 (bdg (cadr ret))
X			 (return-val (isolate-squeezed var-set bdg))
X			 (squeezed-vars (car return-val))
X			 (new-bindings (cadr return-val))
X			 (old-bindings (caddr return-val))
X			 (did-squeeze? (not (null? squeezed-vars)))
X			 (delay-more? (keep? (caar result))))
X			(cond	((and delay-more? did-squeeze?)
X					(arith-debug "DELAY & BIND")
X					(bind! var-set squeezed-vars new-bindings
X						old-bindings goal program
X						(lambda (fail)
X							(scheduler program
X								s fail))
X						(lambda ()
X							(try-bdg (cdr result)
X								goal program
X								s f))))
X				(delay-more?
X					;;; and (not did-squeeze?)
X					(arith-debug "DELAY ONLY")
X					;;; actually delaying on all is NOT
X					;;; essential!
X					(delay! goal var-set 'ANY)
X					(flounder! goal)
X					(s (lambda ()
X						(unflounder! goal)
X						(undelay! goal var-set)
X						(try-bdg (cdr result) goal
X							program s f))))
X				(did-squeeze?
X					;;; and (not delay-more?)
X					(arith-debug "BIND ONLY")
X					(bind! '() squeezed-vars new-bindings
X						old-bindings goal program
X						(lambda (fail)
X							(scheduler program
X								s fail))
X						(lambda ()
X							(try-bdg (cdr result)
X								goal program
X								s f))))
X				(else	(arith-debug "CONTINUE")
X					(s f))))))
X
X;;; Note:  any routine which invokes bind! is responsible for ensuring that
X;;; scheduler will be invoked at some point in the success continuation.
X(define (bind! delay-vars squeezed-vars new-bindings old-bindings
X		goal program s f)
X					;;; assumes that new-bindings consists
X					;;; of only intervals or like-values; ie
X					;;; constraints need not be transferred.
X					;;; instantiates all the squeezed vars
X					;;; FIRST, then wakes constraints on
X					;;; each of them by turn
X	(define (wake-constraints-all var-set program s f)
X					;;; WASTEFUL; this could be optimized
X					;;; to awaken only the sleepy ones.
X					;;; wakes constraints on all the vars
X					;;; by turn
X		(if	(null? var-set)
X			(s f)
X			(var-wake-constraints (car var-set) program
X				(lambda (fail)
X					(wake-constraints-all (cdr var-set)
X						program s fail))
X				f)))
X
X	(arith-debug "in bind!() with new-bindings:")
X	(arith-debug new-bindings)
X	(if	(null? squeezed-vars)
X		(s f)
X		(begin	(map	(lambda (var bdg)
X					(unite! var bdg))
X				squeezed-vars new-bindings)
X			(if	(not (null? delay-vars))
X				(flounder! goal))
X			(wake-constraints-all squeezed-vars program
X				(if	(not (null? delay-vars))
X					(lambda (fail)
X						(map (lambda (var)
X							(var-add-constraint!
X							 goal var 'REAR))
X						     delay-vars)
X						(s fail))
X					s)
X				(if	(not (null? delay-vars))
X					(lambda ()
X						(unflounder! goal)
X						(undelay! goal delay-vars)
X						(restore-var-set 'inst
X							squeezed-vars
X							old-bindings)
X						(f))
X					(lambda ()
X						(restore-var-set 'inst
X							squeezed-vars
X							old-bindings)
X						(f)))))))
X
X(define (isolate-squeezed var-set binding)
X					;;; binding is a list of bindings sans
X					;;; nature
X	(define (f vars bdgs squeezed-vars new-bdgs old-bdgs)
X		(if	(null? vars)
X			(list squeezed-vars new-bdgs old-bdgs)
X			(let*	((var (car vars))
X				(new-val (car bdgs))
X				(old-val (var-val var)))
X				(if	(~<i? new-val old-val)
X					;;; actually squeezed?
X					(f (cdr vars) (cdr bdgs)
X						(cons var squeezed-vars)
X						(cons new-val new-bdgs)
X						(cons old-val old-bdgs))
X					(f (cdr vars) (cdr bdgs) squeezed-vars
X						new-bdgs old-bdgs)))))
X
X	(arith-debug "in isolate-squeezed() with var-set:")
X	(arith-debug (term-instantiate var-set))
X	(arith-debug "and binding:")
X	(arith-debug binding)
X	(f var-set binding '() '() '()))
X
X(define (relax-split program s f)
X	(arith-debug "in relax-split()")
X	(if	(dlist-empty? SPLITTING-GOALS)
X		(s f)			;;; exit to Prolog via success
X		(let*	((old-split-list (backup-split-list))
X			(goal (dlist-delete-front! SPLITTING-GOALS))
X			(g-term (goal-term goal))
X			(name (term-functor g-term))
X			(var-set (term-var-set g-term)))
X			(if	(not (arith-split-prim? name))
X				(error 'relax-split
X					"illegal goal in SPLITTING-GOALS"))
X			(user-debug "executing system predicate:")
X			(user-debug (term-instantiate g-term))
X			(unflounder! goal)
X			(let*	((ret (init-arith! var-set))
X				(uninst-var-set (car ret))
X				(undo-var-set (cadr ret))
X				(undo-bindings (caddr ret))
X				(args (extract-args g-term))
X				(result (useful-bdgs (apply (name->func name)
X								args))))
X					;;; apply instantiated goal, i.e., split
X					;;; perform bindings
X				(bind-split! result goal program s
X					(lambda ()
X						(flounder! goal)
X						(restore-var-set 'uninst
X							uninst-var-set '())
X						(restore-var-set 'inst
X							undo-var-set
X							undo-bindings)
X						(restore-split-list!
X							old-split-list)
X						(f)))))))
X
X(define (useful-bdgs L)			;;; L is a list of bindings
X	(cond	((null? L)
X			'())
X		((not (fail? (caar L)))
X			(cons (car L) (useful-bdgs (cdr L))))
X		(else	(useful-bdgs (cdr L)))))
X
X(define (bind-split! bindings goal program s f)
X					;;; note split takes one arg only
X	(arith-debug "in bind-split!() with bindings:")
X	(arith-debug bindings)
X	(if	(null? bindings)	;;; exhausted splitting alternatives?
X		(f)			;;; note this has not been a successful
X					;;; path of execution!
X		(let*	((old-split-list (backup-split-list))
X			 (ret (map-var-val goal (car bindings)))
X			 (var-set (car ret))
X			 (var-bdg (cadr ret))
X			 (return-val (isolate-squeezed var-set var-bdg))
X			 (squeezed-vars (car return-val))
X			 (new-bindings (cadr return-val))
X			 (old-bindings (caddr return-val))
X			 (did-squeeze? (not (null? squeezed-vars)))
X			 (delay-more? (keep? (caar bindings)))
X					;;; note (caar bindings) is the nature
X			 (success (lambda (fail)
X					(user-debug "continuing after:")
X					(user-debug (term-instantiate
X							(goal-term goal)))
X					(relax-split program s fail)))
X					;;; more splitting on success!
X			 (fail	(lambda ()
X					(user-debug "backtracking to:")
X					(user-debug (term-instantiate
X							(goal-term goal)))
X					(unflounder! goal)
X					(restore-split-list! old-split-list)
X					(bind-split! (cdr bindings) goal
X						program s f))))
X					;;; note (f) not explicitly required as
X					;;; (bind-split! ...) does it!
X
X			(if	delay-more?
X				(begin	(flounder! goal)
X					(dlist-insert-back! goal
X						SPLITTING-GOALS)))
X			(bind! '() squeezed-vars new-bindings old-bindings
X				goal program
X				(lambda (fail)
X					(scheduler program success fail))
X				fail))))
X
X(define (name->func name)
X	(case	name
X		((add)		add)
X		((mult)		mult)
X		((square)	square)
X		((geq)		geq)
X		((gt)		gt)
X		((neq)		neq)
X		((int)		int)
X		((zero-one2)	zero-one2)
X		((zero-one1)	zero-one1)
X		((zero1)	zero1)
X		((split-abs)	split-abs)
X		((split-rel)	split-rel)
X		((split-machine) split-machine)
X		((split)	split)
X		(else		(error 'name->func "bad arith primitive ~s"
X					name))))
X
X(define (name->transform-func name)
X	(case	name
X		((add)		transform-add)
X		((mult)		transform-mult)
X		((square)	transform-square)
X		((geq)		transform-geq)
X		((gt)		transform-gt)
X		((neq)		transform-neq)
X		((int)		transform-int)
X		((zero-one2)	transform-zero-one2)
X		((zero-one1)	transform-zero-one1)
X		((zero1)	transform-zero1)
X		(else		(error 'name->func "bad arith primitive ~s"
X					name))))
X
X(define (arith-primitive? name)
X	(case	name
X		((add mult square geq gt neq int zero-one2 zero-one1 zero1
X		  split-abs split-rel split-machine split)
X			#t)
X		(else	#f)))
X
X(define (arith-split-prim? name)
X	(case	name
X		((split-abs split-rel split-machine split)	#t)
X		(else	#f)))
X
X(define (init-arith-goal-lists!)
X	(set! SPLITTING-GOALS (make-dlist)))
X
X(define (backup-split-list)
X	(arith-debug "in backup-split-list()")
X					;;; note freshly allocated copy is
X					;;; of the essence
X	(list-copy SPLITTING-GOALS))
X
X(define (restore-split-list! old-list)
X	(arith-debug "in restore-split-list!()")
X	(set! SPLITTING-GOALS old-list))
X
X(define (display-goal-lists)
X	(display "Splitting goals:")
X	(newline)
X	(for-each
X		(lambda (goal)
X			(display "  ")
X			(display (term-instantiate (goal-term goal)))
X			(newline))
X		(dlist->list SPLITTING-GOALS)))
X
X(define (show-goal-lists)
X	(arith-debug "SPLITTING-GOALS:")
X	(for-each
X		(lambda (goal)
X			(arith-debug (term-instantiate (goal-term goal))))
X		(dlist->list SPLITTING-GOALS)))
X
X;;; global list
X(define SPLITTING-GOALS (make-dlist))
END_OF_FILE
if test 15963 -ne `wc -c <'prolog1.2/Interval/relax.ss'`; then
    echo shar: \"'prolog1.2/Interval/relax.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/Interval/relax.ss'
fi
echo shar: End of archive 3 \(of 3\).
cp /dev/null ark3isdone
MISSING=""
for I in 1 2 3 ; do
    if test ! -f ark${I}isdone ; then
	MISSING="${MISSING} ${I}"
    fi
done
if test "${MISSING}" = "" ; then
    echo You have unpacked all 3 archives.
    rm -f ark[1-9]isdone
else
    echo You still need to unpack the following archives:
    echo "        " ${MISSING}
fi
##  End of shell archive.
exit 0
